% INTERPOLAZIONE POLINOMIALE A TRATTI
% 			Confronto dei metodi forniti da MATLAB per interpolazione 
% 			polinomiale a tratti di dati 2D  
% METODO NEAREST NEIGHBOR: il valore del punto interpolato 
%					e' il valore del punto piu' vicino
% METODO BILINEAR: 	il valore del punto interpolato 
%					e' una combinazione dei valori
%					dei 4 punti vicini
% METODO NEAREST NEIGHBOR: il valore del punto interpolato 
%					e' una combinazione dei valori
%					dei 16 punti vicini
close all
% griglia 7x7 di dati da interpolare 
[x,y]=meshgrid(-3:1:3);
z=peaks(x,y);
surf(x,y,z);
%hold on;
plot3(x,y,z,'.','MarkerSize',15);grid;

% genera una griglia per la valutazione e visualizzazione
% della superficie interpolante
[xi,yi]=meshgrid(-3:0.25:3);

% costruisci superficie di interpolazione con tecnica 'nearest neighbor'
zi1=interp2(x,y,z,xi,yi,'nearest');

% costruisci superficie di interpolazione con tecnica 'bilineare'
zi2=interp2(x,y,z,xi,yi,'bilinear');

% costruisci superficie di interpolazione con tecnica 'bicubica'
zi3=interp2(x,y,z,xi,yi,'bicubica');
pause
figure;
% surface plot
surf(xi,yi,zi1);pause;figure;

surf(xi,yi,zi2);pause;figure;

surf(xi,yi,zi3);pause;figure;

% contour plot
contour(xi,yi,zi1);pause;figure;

contour(xi,yi,zi2);pause;figure;

contour(xi,yi,zi3);

% Esempio di interpolazione per  
% dati originali distribuiti non in modo uniforme
x=rand(100,1)*2*pi;y=rand(100,1)*pi;z=sin(x).*cos(y);
% costruzione di una grigli auniforme a partire dai dati originali
xlin=linspace(min(x),max(x),40);
ylin=linspace(min(y),max(y),40);
[X,Y]=meshgrid(xlin,ylin);
% utilizza la funzione griddata per interpolare (con interpolazione cubica)
% i dati x,y originali sulla matrice uniforme di dati
Z=griddata(x,y,z,X,Y,'cubic');
% plot della superficie
mesh(X,Y,Z);
hold on;
% plot dei dati non uniformi sulla superficie
plot3(x,y,z,'.','MarkerSize',15);
figure;

